bits 16 ; tell NASM this is 16 bit code
cpu 8086

%define CURRENT_LEVEL 0x7E00
%define CURRENT_LEVEL_2 0x7E02
%define SCREEN_DS 0xb800
%define HISTORY SCREEN_DS

%define MDA_SUPPORT		+7 bytes
 %define MDA_CGA40		+25 bytes
%define MOVE_COUNT		+20 bytes
%define UNDO			+35 bytes
 %define FAST_UNDO		+5 bytes

%define COL80 80
%define COL40 40
%ifdef MDA_SUPPORT
 %define COLS  COL80
%else
 %define COLS  COL40
%endif
%define LINES 25

boot:
tail:
    call get_data
    
; data section:

;  0000 0000 EMPTY
;  0000 0001 SPOT
;  0000 0010 BRICK
%define BRICK 2
;  0000 0011 BRICK ON SPOT
;  0000 0100 WALL
;  0000 0101 OUTSIDE
;  0000 0110 PLAYER
%define PLAYER 6
;  0000 0111 PLAYER ON SPOT
display_chars: db 0,    0x07 ; blank
               db 0xF9, 0x07 ; spot
               db 0xFE, 0x0A ; brick
%ifdef MDA_SUPPORT
               db 4,    0x0C ; brick on spot
%else
               db 0xFE, 0x0C ; brick on spot
%endif
               db 0xB0, 0x71 ; wall
               db 0,    0x07 ; out blank 
               db 1,    0x0F ; player
               db 1,    0x0F ; player on spot

str_you_win: db 'YOU WIN! ',1,1,1

test_level:

%define p(a,b,c) ((c&7)+((b&7)*6)+((a&7)*6*6))
%define LEVEL 2

;# convert a sokojs level
;echo ";$1"
;sed '/^" /!d;s|^" ||;s|".*||;y|_.$*# @+|012345@Z|' $1 | awk 'BEGIN { q=""; l=0 }
;function out() {
;  line[l] = ""
;  while (length(q) > 2) {
;    line[l] = line[l] sprintf(" p(%c,%c,%c),", substr(q,1,1), substr(q,2,1), substr(q,3,1))
;    q = substr(q,4)
;  }
;  l++
;}
;{ if (index($0,"@") > 0) { px=l; py=index($0,"@")-1 }
;  if (index($0,"Z") > 0) { px=l; py=index($0,"Z")-1 }
;  r=length($0); q = q $0; out()
;}
;END { q = q "55"; if (length(q) > 2) out()
;  print "%define WIDTH " r; print "%define HEIGHT " l
;  print "%define PLAYERXY WIDTH*" px "+" py "  ; " r*px+py
;  if ((r*px+py) % 256 >= 90 ) print "%define EOS PLAYERXY"
;  print "    dw PLAYERXY"
;  for (i = 0; i < l; i++) print line[i]
;}' | sed 's|,$||;s|^ p|    db p|;s|@|0|;s|Z|1|'

%if LEVEL == 1
;sokojs sokojs/level57.htm
%define WIDTH 14
%define HEIGHT 10
%define PLAYERXY WIDTH*4+7
%define EOS PLAYERXY
    dw PLAYERXY
    db p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(5,5,          4)
    db   p(1,1,        0), p(0,4,0), p(0,0,0), p(0,4,4), p(4,  4,1)
    db     p(1,      0,0), p(4,0,2), p(0,0,2), p(0,0,4)
    db p(4,1,1), p(0,0,4), p(2,4,4), p(4,4,0), p(0,4,          4)
    db   p(1,1,        0), p(0,0,0), p(8,0,4), p(4,0,0), p(4,  4,1)
    db     p(1,      0,0), p(4,0,4), p(0,0,2), p(0,4,4)
    db p(4,4,4), p(4,4,4), p(0,4,4), p(2,0,2), p(0,4,          5)
    db   p(5,4,        0), p(2,0,0), p(2,0,2), p(0,2,0), p(4,  5,5)
    db     p(4,      0,0), p(0,0,4), p(0,0,0), p(0,0,4)
    db p(5,5,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,          5)
%elif LEVEL == 2
;sokojs sokojs/level83.htm modified
%define WIDTH 15
%define HEIGHT 14
%define PLAYERXY WIDTH*7+13
%define EOS PLAYERXY
    dw PLAYERXY
    db p(4,4,4), p(4,5,5), p(5,5,5), p(4,4,4), p(4,5,5)
    db p(4,0,0), p(4,4,4), p(4,4,4), p(4,1,1), p(4,4,4)
    db p(4,0,2), p(0,2,0), p(2,0,0), p(4,1,1), p(1,1,4)
    db p(4,0,2), p(0,0,0), p(2,2,0), p(4,3,3), p(3,1,4)
    db p(4,0,2), p(0,2,0), p(2,0,0), p(4,1,1), p(3,1,4)
    db p(4,0,0), p(2,0,2), p(0,2,0), p(4,3,1), p(3,1,4)
    db p(4,4,0), p(2,0,2), p(0,2,0), p(1,3,1), p(3,1,4)
    db p(4,0,0), p(2,0,2), p(0,2,0), p(1,3,1), p(3,1,4)
    db p(4,0,0), p(2,0,2), p(0,2,0), p(4,3,1), p(3,1,4)
    db p(4,0,2), p(0,2,0), p(2,0,0), p(4,1,1), p(3,1,4)
    db p(4,0,2), p(0,0,0), p(2,2,0), p(4,3,3), p(3,1,4)
    db p(4,0,2), p(0,2,0), p(2,0,0), p(4,1,1), p(1,1,4)
    db p(4,0,0), p(4,4,4), p(4,4,4), p(4,1,1), p(4,4,4)
    db p(4,4,4), p(4,5,5), p(5,5,5), p(4,4,4), p(4,5,5)
%elif LEVEL == 3
;sokojs ALDMGR/level0.htm
%define WIDTH 19
%define HEIGHT 18
%define PLAYERXY WIDTH+8
%define EOS PLAYERXY
    dw PLAYERXY
    db p(5,5,5), p(5,5,5), p(5,4,4), p(4,5,5), p(5,5,5), p(5,5,5), p(5,     5,5)
    db     p(4,      4,4), p(4,4,0), p(8,0,4), p(4,4,4), p(4,4,4), p(5,5,   5)
    db   p(5,4,        0), p(0,0,4), p(0,2,0), p(4,0,0), p(0,0,0), p(4,4,5)
    db p(5,4,4), p(0,2,0), p(4,4,0), p(0,4,2), p(0,0,0), p(0,0,4), p(4,     5,4)
    db     p(0,      2,0), p(2,0,4), p(0,0,4), p(0,2,4), p(4,0,2), p(0,4,   4)
    db   p(4,0,        3), p(1,1,0), p(4,4,0), p(4,2,0), p(4,4,2), p(0,0,4)
    db p(4,0,2), p(1,1,3), p(0,0,4), p(0,4,0), p(2,0,0), p(0,0,4), p(4,     4,0)
    db     p(3,      2,4), p(2,3,0), p(4,2,0), p(0,0,2), p(0,0,4), p(4,5,   4)
    db   p(1,1,        0), p(4,0,1), p(1,4,0), p(0,4,4), p(4,2,4), p(4,5,5)
    db p(4,0,4), p(4,4,4), p(4,0,4), p(0,2,0), p(0,2,0), p(0,4,4), p(5,     4,0)
    db     p(2,      0,4), p(0,2,0), p(0,2,0), p(2,0,2), p(0,2,0), p(4,4,   4)
    db   p(0,1,        1), p(4,1,1), p(0,2,0), p(4,0,0), p(0,2,0), p(2,0,4)
    db p(4,0,1), p(1,2,1), p(1,0,4), p(0,4,0), p(2,4,4), p(0,0,0), p(4,     4,0)
    db     p(1,      1,1), p(1,1,2), p(4,0,4), p(0,0,0), p(0,0,2), p(0,4,   4)
    db   p(0,1,        1), p(1,1,1), p(0,4,0), p(4,2,2), p(2,0,2), p(0,4,4)
    db p(4,0,1), p(1,1,1), p(1,2,4), p(0,4,0), p(0,0,0), p(0,4,4), p(5,     4,0)
    db     p(1,      1,1), p(1,1,0), p(4,0,4), p(4,4,4), p(4,4,4), p(5,5,   5)
    db   p(4,4,        4), p(4,4,4), p(4,5,4), p(5,5,5), p(5,5,5), p(5,5,5)
%else
;sokojs David_W_Skinner_Arranged/level174.htm
%define WIDTH 30
%define HEIGHT 20
%define PLAYERXY WIDTH*7+12  ; 222
%define EOS PLAYERXY
    dw PLAYERXY
    db p(5,5,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,5,5)
    db p(5,5,4), p(0,0,0), p(0,4,0), p(0,0,0), p(4,0,0), p(0,0,4), p(0,0,0), p(0,4,0), p(0,0,0), p(4,5,5)
    db p(4,4,4), p(1,2,2), p(1,4,1), p(2,2,1), p(4,1,2), p(2,1,4), p(1,2,2), p(1,4,1), p(2,2,1), p(4,4,4)
    db p(4,0,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,3,0), p(0,3,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,0,4)
    db p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4), p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4)
    db p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4), p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4)
    db p(4,0,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,3,0), p(0,3,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,0,4)
    db p(4,4,4), p(1,2,2), p(1,0,1), p(2,2,1), p(0,1,2), p(2,1,0), p(1,2,2), p(1,0,1), p(2,2,1), p(4,4,4)
    db p(4,0,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,3,0), p(0,3,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,0,4)
    db p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4), p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4)
    db p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4), p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4)
    db p(4,0,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,3,0), p(0,3,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,0,4)
    db p(4,4,4), p(1,2,2), p(1,0,1), p(2,2,1), p(0,1,2), p(2,1,0), p(1,2,2), p(1,0,1), p(2,2,1), p(4,4,4)
    db p(4,0,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,3,0), p(0,3,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,0,4)
    db p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4), p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4)
    db p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4), p(4,0,2), p(0,4,4), p(0,2,0), p(4,4,0), p(2,0,4)
    db p(4,0,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,3,0), p(0,3,1), p(3,0,0), p(3,1,3), p(0,0,3), p(1,0,4)
    db p(4,4,4), p(1,2,2), p(1,4,1), p(2,2,1), p(4,1,2), p(2,1,4), p(1,2,2), p(1,4,1), p(2,2,1), p(4,4,4)
    db p(5,5,4), p(0,0,0), p(0,4,0), p(0,0,0), p(4,0,0), p(0,0,4), p(0,0,0), p(0,4,0), p(0,0,0), p(4,5,5)
    db p(5,5,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,4,4), p(4,5,5)
%endif

get_data:
    pop bp   
%define BP(x) [bp+x-display_chars]
    ; set up stack
    push cs
    pop ss
    xor sp, sp

%ifdef MDA_SUPPORT
 %ifdef MDA_CGA40
    ; screen memory in text mode
    mov cx, SCREEN_DS
.init_es:
%define patch_ofs 0x170
%define BPDI(x) [bp+di+x-display_chars-patch_ofs]
    mov di, patch_ofs
    xor word BPDI(patch_win_pos), ((COL40 * 12 + COL40/2 - 6) * 2) ^ ((COL80 * 12 + COL80/2 - 6) * 2)
    xor word BPDI(patch_middle), ((25 * COL40) - (WIDTH & 0xFE) - (COL40 * (HEIGHT & 0xFE))) ^ ((25 * COL80) - (WIDTH & 0xFE) - (COL80 * (HEIGHT & 0xFE)))
    xor byte BPDI(patch_next_row),((COL40 - WIDTH) * 2) ^ ((COL80 - WIDTH) * 2)
    xor word BPDI(patch_count_pos),(COL40 + 2 + (LINES-1)*COL40*2) ^ (COL80 + 2 + (LINES-1)*COL80*2)
    mov es, cx
    mov ch, 0xb0
    inc byte [es:di]
    je .init_es
 %endif
%endif
restart:
    cld
    sti             ; Allow interrupts

    push cs
    pop ds
    
%ifdef UNDO
    mov word [HISTORY], sp
%endif

back:
    call init_data
%ifdef UNDO
    mov word BP(tail), es ; HISTORY = es
%endif

mainloop:
    ; read key
    xor ax, ax
    cwd
%ifdef UNDO
    mov si, BP(tail)
    or ah, [si]
    jnz .arrows
%endif
.wait_for_esc:
    int 0x16

    dec ah ; esc
    je quit

.chk_restart:    
    or dx, dx
    jne restart

.arrows:    
    xchg al, ah
    
    inc dx
    cmp al, 0x4d-1 ; right arrow
    je  .try_move_right
    cmp al, 0x4b-1 ; left arrow
    je  .try_move_left

    mov dl, WIDTH ; (width of current level) to the right = 1 down
    cmp al, 0x50-1 ; down arrow
    je  .try_move_down
    cmp al, 0x48-1 ; up arrow
%ifdef UNDO
    je  .try_move_up

    sub al, 0xE-1 ; backspace
    jne .redraw
    mov [si-1], al
    jmp back
%else
    jne .redraw
%endif
    
.try_move_left:
.try_move_up:
    neg dx
.try_move_right:
.try_move_down:

%ifdef UNDO
    xchg [si], al
    inc si
    mov BP(tail), si
    or al, al
    jnz .not_end
    mov [si], ax
.not_end:
%endif
    
    call try_move

%ifdef UNDO
  %ifdef FAST_UNDO
    lodsw
    or ah, ah
    jnz mainloop
  %endif
%endif

.redraw:
    call draw_current_level

    dec bx
    jne mainloop	; found a spotless brick

win:
    ; print a nice win message to the middle of the screen
    lea si, BP(str_you_win)

    ; destination position on screen
    mov di, (COLS * 12 + COLS/2 - 6) * 2
patch_win_pos   equ     $ - 2

.loop:
    lodsb

%ifdef EOS
 %if EOS & 0x80 == 0
    cbw
 %else
    mov ah, 0
 %endif
    cmp al, EOS & 255
    je mainloop.wait_for_esc
%else
    cbw
    cmp al, 'Z'
    ja mainloop.wait_for_esc
%endif

    mov ah, 0x0F
    stosw
    jmp .loop


;; functions:

quit:
    mov ax, 0x0003  ; text mode 80x25 16 colours
    int 0x10
    int 0x20
    int 0x19
    
init_data:
%ifdef MDA_SUPPORT
 %ifdef MDA_CGA40
    push es
 %endif
%endif
    ; clear screen (re-set text mode)
    mov ax, 0x0001  ; text mode 40x25 16 colours
    int 0x10

    ; disable cursor
    mov ah, 0x01
    mov ch, 0x3f
    int 0x10

    ; set current level to test level by copying
    lea si, BP(test_level)

    push cs
    pop es
    mov di, CURRENT_LEVEL ; next address to copy to

    ; copy player position ("uncompressed")
    movsw

    mov cx, (( WIDTH * HEIGHT ) +2 ) /3
uncompress:
    ; load one "compressed" byte and store 3 "uncompressed" bytes
    lodsb
    ; aam n:  ah = al / n  al = al % n 
    aam 36
    mov [di], ah ; p/6/6
    inc di
    aam 6
    xchg al, ah
    stosw	; p/6%6 p%6

    loop uncompress
    or byte [di - ((( WIDTH * HEIGHT ) +2 ) /3)*3 + PLAYERXY], PLAYER

%ifdef MDA_SUPPORT
  %ifdef MDA_CGA40
    pop es
  %else
    ; screen memory in text mode
    mov ch, SCREEN_DS/256
.init_es:
    mov es, cx
    mov ch, 0xb0
    mov al, 0xff
    scasb
    je .init_es
  %endif
%else
    ; screen memory in text mode
    mov ch, SCREEN_DS/256
    mov es, cx
  %if 1
    mov al, 0xff
    scasb
    je quit
  %endif
%endif
    
draw_current_level:

    ; print in the middle and not in the corner
    mov di, (25 * COLS) - (WIDTH & 0xFE) - (COLS * (HEIGHT & 0xFE))
patch_middle   equ     $ - 2

    mov si, CURRENT_LEVEL_2 ; source byte
    mov bx, HEIGHT * 256 + 1
.looph:
    mov cx, WIDTH
.loop:
    lodsb
    cbw
    cmp al, BRICK	; spotless brick
    jne .not_brick
%ifdef HUGE_SPOTLESS_COUNT
    mov bl, al
%else
    inc bx		; 254 max
%endif
.not_brick:
    xchg ax, si
    add si, si
    mov si, BP(si+display_chars)
    xchg ax, si
    
    stosw

    ; subtract 1 from X axis counter
    loop .loop

    ; jump to next row down
patch_next_row  equ  $ + 2
    add di, (COLS - WIDTH) * 2

    dec bh ; subtract 1 from Y axis counter
    jnz .looph
    ret

try_move:
    ; try to move the player
    ; dx = offset of how much to move by

    mov di,CURRENT_LEVEL_2

    ; calculate requested destination position
    mov bx, dx
    add bx, [di - 2]

    ; get value at destination position
    cmp byte [bx + di], 4
    je .cant_push ; it's a wall
    test byte [bx + di], 0x02
    jz .dont_push ; it's not a brick (on spot, or not), so don't try pushing

    ; try pushing brick
    mov ax, bx ; store player's destination position (brick's current position)
    add bx, dx ; bx = next brick position

    ; get value at destination position
    test byte [bx + di], 0x0E ; test if the destination is occupied at all by ANDing with 0000 1110
    jnz .cant_push

    ; all checks passed! push the brick
    mov dl, BRICK
    call .move_object
%ifdef OPEN_LEVEL
    jc  .cant_push
%endif

%ifdef MOVE_COUNT
    push di
    mov di, COLS + 2 + (LINES-1)*COLS*2
patch_count_pos  equ  $ - 2
.chk_score:
    dec di
    dec di
    mov al, '0'
    xchg [es:di], al
    or al, 0x30
    cmp al, '9'
    je .chk_score
    inc ax
    stosb
    pop di
%endif

.dont_push:
    mov ax, bx ; bx = next player position
    xchg ax, [di - 2] ; update player position in memory
    ; ax = current player position

    mov dl, PLAYER
.move_object:
%ifdef OPEN_LEVEL
    ; check bounds
    cmp bx, WIDTH * HEIGHT
    cmc
    jc  .cant_push
%endif
    ; add new object to screen
    or byte [bx + di], dl ; add object bits
    ; remove old object from screen
    xchg ax, bx
    xor byte [bx + di], dl ; remove object bits

.cant_push:
    ret


times 510 - ($-$$) db 0 ; pad remaining 510 bytes with zeroes
dw 0xaa55 ; magic bootloader magic - marks this 512 byte sector bootable!
